<?php

namespace goodboyalex\php_components_pack\enums;

use goodboyalex\php_components_pack\traits\EnumExtensionsTrait;

/**
 * Перечисление типов действий, которые необходимо выполнить, если переменная не является булевым типом.
 *
 * @author Александр Бабаев
 * @package php_components_pack
 * @version 1.0
 * @since 1.0.19
 */
enum VarNotBoolAction: int
{
    // Подключаю расширение для Enum
    use EnumExtensionsTrait;

    /**
     * Игнорировать это утверждение.
     */
    case Ignore = 0;

    /**
     * Считать это утверждение истинным.
     */
    case ConsiderItTrue = 1;

    /**
     * Считать это утверждение ложным.
     */
    case ConsiderItFalse = 2;
}